###############################################################################
# Résolution d'une équation du premier ordre à l'aide de solve_ivp #
###############################################################################

from scipy.integrate import solve_ivp
from pylab import *

# données 1 : caractéristiques du système
K=1       # gain
tau=0.1   # constante de temps en s

# données 2 : paramètres de calcul
t0 = 0    # instant initiale (secondes)
tf = 1    # instant final (secondes)
p = 0.01   # pas maxi de calcul (secondes)
# Dans la méthode d'intégration de solve_ivp le pas est variable. On fixera ici seulement sa valeur maximale.

# définition de l'entrée
def e(t):
    return 1

# formulation de Cauchy
# définition de l'équadiff sous la forme f'(t)=...
# e est la fonction de t définie préalablement
# s est la sortie à calculer
def eqdf(t,s):
    # attention c'est t puis s en arguments !!! L'inverse d'odeint !
    return (1/tau)*(K*e(t)-s)

# condition initiale et résolution
s0 = 0
S = solve_ivp(eqdf,[t0,tf],[s0],max_step=p)
# génère S.t et S.y[0] qui sont respectivement les listes des instants et des valeurs correspondantes

# affichage de s(t)
plot(S.t,S.y[0])
grid()
show()

